package {
	import flash.display.Sprite;
	import flash.events.Event;
	import com.fileitup.fisixengine.core.FisixEngine;
	import com.fileitup.fisixengine.collisions.ReactionModes;
	import com.fileitup.fisixengine.core.FisixObject;
	import com.fileitup.fisixengine.core.Vector;
	import flash.events.MouseEvent;
	import com.fileitup.fisixengine.particles.CircleParticle;

	[SWF(width="350", height="300", frameRate="30", backgroundColor="0xEEEEEE")]
	public class Exam_Particle extends Sprite
	{
		private var myEngine:FisixEngine;
		
		public function Exam_Particle()
		{
			//엔진 기본 설정
			myEngine = new FisixEngine();
			myEngine.setReactionMode(ReactionModes.PHYSICAL);
			myEngine.setGravity(0,1);
			myEngine.setRender(true);
			myEngine.setRenderGraphics(graphics);
			this.addEventListener(Event.ENTER_FRAME, on_EnterFrame);
			//아래부터 내용 작성
			this.drawWalls(myEngine);//벽 만들기
			this.drawPillars(myEngine);//기둥 만들기
			this.drawResistances(myEngine, 7, 70);//저항 만들기
			this.drawResistances(myEngine, 5, 100);//저항 만들기
			this.drawResistances(myEngine, 9, 130);//저항 만들기
			this.stage.addEventListener(MouseEvent.MOUSE_DOWN, on_MouseDown);//파티클 생성
		}
		private function on_EnterFrame(e:Event):void {
			myEngine.mainLoop(1);
		}
		/**
		 * 벽 만들기
		 */
		private function drawWalls(_engine:FisixEngine):void {
			var walls:FisixObject = _engine.newFisixObject();
			var W:Number = this.stage.stageWidth;
			var H:Number = this.stage.stageHeight;
			walls.newSurface(new Vector(0,0),new Vector(W,0),10);
			walls.newSurface(new Vector(W,0),new Vector(W,H),10);
			walls.newSurface(new Vector(W,H),new Vector(0,H),10);
			walls.newSurface(new Vector(0,H),new Vector(0,0),10);
			walls.makeStatic();
		}
		/**
		 * 기둥 만들기
		 */
		private function drawPillars(_engine:FisixEngine):void {
			var pillars:FisixObject = _engine.newFisixObject();
			var pNum:int = 5;//객체 수
			var H:Number = this.stage.stageHeight;
			var bW:Number = this.stage.stageWidth/(pNum+1);
			var bH:Number = H/(pNum+1);
			for(var i:int=0; i<pNum; i++){
				pillars.newSurface(new Vector(bW*(i+1),H),new Vector(bW*(i+1),H-100),10);
			}
			pillars.makeStatic();
		}
		/**
		 * 저항 만들기
		 */
		private function drawResistances(_engine:FisixEngine, pNum:uint, _height:Number):void {
			var resistances:FisixObject = _engine.newFisixObject();
			var H:Number = this.stage.stageHeight;
			var bW:Number = this.stage.stageWidth/(pNum+1);
			var bH:Number = H/(pNum+1);
			var cp:CircleParticle;
			for(var i:int=0; i<pNum; i++){
				cp = new CircleParticle(bW*(i+1), _height, 5);
				cp.color = 0;
				resistances.addObject(cp);
			}
			resistances.makeStatic();
		}
		/**
		 * 파티클 생성
		 */
		private function on_MouseDown(e:MouseEvent):void {
			var cp:CircleParticle = new CircleParticle(e.localX, e.localY, 10);
			this.myEngine.addObject(cp);
		}
	}
}
